---
title: Resize Observer API
slug: Web/API/Resize_Observer_API
tags:
  - API
  - Draft
  - Element
  - Monitor
  - Overview
  - Reference
  - Resize Observer
  - Resize Observer API
  - observe
  - size
---
<p>{{DefaultAPISidebar("Resize Observer API")}}</p>

<p>The Resize Observer API provides a performant mechanism by which code can monitor an element for changes to its size, with notifications being delivered to the observer each time the size changes.</p>

<h2 id="Concepts_and_usage">Concepts and usage</h2>

<p>There are a whole raft of use cases for responsive design techniques (and others besides) that respond to changes in an element's size, but previously their implementations have often been hacky and/or brittle.</p>

<p>For example, <a href="/en-US/docs/Web/CSS/Media_Queries">media queries</a> / {{domxref("window.matchMedia")}} are great for updating layouts at specific points when the viewport changes sizes, but what if you want to change layout in response to a specific element's size changing, which isn't the outer container?</p>

<p>To achieve this, a limited solution would be to listen to changes to a suitable event that hints at the element you are interested in changing size (e.g. the window <a href="/en-US/docs/Web/API/Window/resize_event">resize event</a>), then figure out what the new dimensions or other features of the element after a resize using {{domxref("Element.getBoundingClientRect")}} or {{domxref("Window.getComputedStyle")}}, for example.</p>

<p>Such a solution tends to only work for limited use cases, be bad for performance (continually calling the above methods would result in a big performance hit), and often won't work when the browser window size is not changed.</p>

<p>The Resize Observer API provides a solution to exactly these kinds of problems, and more besides, allowing you to easily observe and respond to changes in the size of an element’s content or border box in a performant way. It provides a JavaScript solution to the often-discussed lack of <a href="https://www.xanthir.com/b4PR0">element queries</a> in the web platform.</p>

<p>Usage is simple, and pretty much the same as other observers, such as <a href="/en-US/docs/Web/API/PerformanceObserver">Performance Observer</a> or <a href="/en-US/docs/Web/API/Intersection_Observer_API">Intersection Observer</a> — you create a new {{domxref("ResizeObserver")}} object using the <code><a href="/en-US/docs/Web/API/ResizeObserver/ResizeObserver">ResizeObserver()</a></code> constructor, then use {{domxref("ResizeObserver.observe()")}} to make it look for changes to a specific element's size. A callback function set up inside the constructor then runs every time the size changes, providing access to the new dimensions and allowing you to do anything you like in response to those changes.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("ResizeObserver")}}</dt>
 <dd>Provides the ability to register new observers and to start and stop observing elements.</dd>
 <dt>{{domxref("ResizeObserverEntry")}}</dt>
 <dd>Describes a single element which has been resized, identifying the element and its new size.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>You find a couple of simple examples on our GitHub repo:</p>

<ul>
 <li><a href="https://mdn.github.io/dom-examples/resize-observer/resize-observer-border-radius.html">resize-observer-border-radius.html</a> (<a href="https://github.com/mdn/dom-examples/blob/master/resize-observer/resize-observer-border-radius.html">see source</a>): A simple example with a green box, sized as a percentage of the viewport size. When the viewport size is changed, the box's rounded corners change in proportion to the size of the box. We could just implement this using {{cssxref("border-radius")}} with a percentage, but that quickly leads to ugly-looking elliptical corners, whereas the above solution gives you nice square corners that scale with the box size.</li>
 <li><a href="https://mdn.github.io/dom-examples/resize-observer/resize-observer-text.html">resize-observer-text.html</a> (<a href="https://github.com/mdn/dom-examples/blob/master/resize-observer/resize-observer-text.html">see source</a>): Here we use the resize observer to change the {{cssxref("font-size")}} of a header and paragraph as a slider’s value is changed causing the containing <code>&lt;div&gt;</code> to change width. This shows that you can respond to changes in an element’s size, even if they have nothing to do with the viewport.</li>
</ul>

<p>The code will usually follow this kind of pattern (taken from resize-observer-border-radius.html):</p>

<pre class="brush: js notranslate">const resizeObserver = new ResizeObserver(entries =&gt; {
  for (let entry of entries) {
    if(entry.contentBoxSize) {
      entry.target.style.borderRadius = Math.min(100, (entry.contentBoxSize.inlineSize/10) +
                                                      (entry.contentBoxSize.blockSize/10)) + 'px';
    } else {
      entry.target.style.borderRadius = Math.min(100, (entry.contentRect.width/10) +
                                                      (entry.contentRect.height/10)) + 'px';
    }
  }
});

resizeObserver.observe(document.querySelector('div'));</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Resize Observer')}}</td>
   <td>{{Spec2('Resize Observer')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ResizeObserver")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://developers.google.com/web/updates/2016/10/resizeobserver">ResizeObserver: It’s Like document.onresize for Elements</a></li>
</ul>
